require ("guis")
require ("register_buildings")
--script.on_event(defines.events.on_console_chat, function(event)
--	if event.message =="start" then
--script.on_load(function()
--if not global.items then
require("ITEMS")
require("itemmarket_guis")
require("ingredientcalc")
require("rpg_framework")
--end
--end)
require("SETTINGS")
remote.add_interface("dota_scenario_running", {
		modify_spirit = function(player, value) 
			if remote.interfaces["spell-pack"] then
				local player_id = player.index
				local players =remote.call("spell-pack","get","players")
				local color = global.players[player_id].color
				for id, player in pairs(global.players) do
					if player.color ==color then
						players[id].spirit = math.max(0,players[id].spirit +value)
					end
				end
				remote.call("spell-pack","set","players",players)
				
			end
		
		end
	  })
	  
script.on_init( function()
	global.on_tick = {}
	rebuild_recipes()
	make_items()
	global.talents = {
	r={
		["t1"] = {type = "force", modifier = "ammo_damage_modifier", value = 0.02},
		["t2"] = {type = "force", modifier = "ammo_damage_modifier", value = 0.0006, periodical = 0},
		["t3"] = {type = "force", modifier = "gun_speed_modifier", value = 0.03},
		["t4"] = {type = "other", modifier = "crit", value = 0.01},
		["t5"] = {type = "other", modifier = "critdamage", value = 0.02},
		["t6"] = {type = "other", modifier = "chardamage", value = 1},
		["t7"] = {type = "force", modifier = "turret_attack_modifier", value = 0.02},
		["t8"] = {type = "other", modifier = "reflect", value = 0.3},
		["t9"] = {type = "other", modifier = "reflect", value = 0.01, periodical = 0},
	},
	g={	
		["t10"] = {type = "other", modifier = "income", value = 0.02},
		["t11"] = {type = "force", modifier = "character_health_bonus", value = 10},
		["t12"] = {type = "force", modifier = "character_health_bonus", value = 0.3, periodical = 0},
		["t13"] = {type = "other", modifier = "regen", value = 0.3},
		["t14"] = {type = "other", modifier = "regen", value = 0.01, periodical = 0},
		["t15"] = {type = "other", modifier = "armor", value = 1},
		["t16"] = {type = "other", modifier = "armor", value = 0.03, periodical = 0},
		["t17"] = {type = "force", modifier = "character_running_speed_modifier", value = 0.015},
	},
	b={	
		["t18"] = {type = "force", modifier = "manual_mining_speed_modifier", value = 0.1},
		["t19"] = {type = "force", modifier = "manual_crafting_speed_modifier", value = 0.05},
		["t20"] = {type = "force", modifier = "character_inventory_slots_bonus", value = 1},
	},
}
	if game.active_mods["spell-pack"] then
		--global.talents.b["t21"] = {type = "other", modifier = "magic_resistance", value = 2}
		--global.talents.b["t22"] = {type = "other", modifier = "magic_resistance", value = 0.06, periodical = 0}
		global.talents.b["t23"] = {type = "spellpack", modifier = "max_mana", value = 2}
		global.talents.b["t24"] = {type = "spellpack", modifier = "max_mana", value = 0.06, periodical = 0}
		global.talents.b["t25"] = {type = "spellpack", modifier = "mana_reg", value = 0.05}
	end
	global.talent_localizations = {
		["t1"]="+2% Damage",
		["t2"]="+0.06% Damage/minute",
		["t3"]="+3% Attackspeed",
		["t4"]="+1% Crit",
		["t5"]="+2% Critdamage",
		["t6"]="+1 Melee Damage",
		["t7"]="+2% Turret Damage",
		["t8"]="+0.3 Thorns Damage",
		["t9"]="+0.01 Thorns Damage/minute",
		["t10"]="+0.02 Gold/s",
		["t11"]="+10 Health",
		["t12"]="+0.3 Health/minute",
		["t13"]="+0.3 HP/s",
		["t14"]="+0.01 HP/s/minute",
		["t15"]="+1 Armor",
		["t16"]="+0.03 Armor/minute",
		["t17"]="+1.5% Running speed",	
		["t18"]="+10% Mining Speed",
		["t19"]="+5% Crafting Speed",
		["t20"]="+1 Inventory Slot",
		--["t21"]="+2 Magic resistance",
		--["t22"]="+0.06 Magic resistance/minute",
		["t23"]="+2 Mana",
		["t24"]="+0.06 Mana/minute",
		["t25"]="+0.05 Manareg",
		}
end)
--script.on_event(defines.events.on_player_crafted_item, function(event)
--	if global.recipes[event.recipe.name] then
--		local ingr = global.recipes[event.recipe.name].raw
--		local inte = global.recipes[event.recipe.name].intermediates
--		game.players[1].print(event.recipe.name..":")
--		for name, count in pairs(ingr) do
--			game.players[1].print(name.." = "..count)
--		end
--		game.players[1].print("intermediates:")
--		for name, count in pairs(inte) do
--			game.players[1].print(name.." = "..count)
--
--		end
--	else
--		--global.temp = ""
--		print("no data found")
--		local ingr = rawingredients(event.recipe)
--		game.players[1].print(event.recipe.name..":")
--		for name, count in pairs(ingr) do
--			if name~="intermediates" then
--				game.players[1].print(name.." = "..count)
--			end
--		end
--		if ingr.intermediates then
--			game.players[1].print("intermediates:")
--			for name, count in pairs(ingr.intermediates) do
--				game.players[1].print(name.." = "..count)
--
--			end
--		end
--	end
--	if global.database[event.recipe.name] then
--		print("itemdb")
--	else
--		print("no itemdb")
--	end
--end)
function init()
	local tiles =game.surfaces[1].find_tiles_filtered{name = "stone-path"}      
	for _, tile in pairs(tiles) do          
		local wall=game.surfaces[1].create_entity{name="stone-wall", position=tile.position, force=neutral}          
		wall.destructible = false     
	end
	global.silos =game.surfaces[1].find_entities_filtered{name = "dota-silo"}
	
	local turrets_red= game.surfaces[1].find_entities_filtered{name = "dota-rocket-red"}
	global.turrets =game.surfaces[1].find_entities_filtered{name = "dota-rocket-blue"}
	for _, turret in pairs(turrets_red) do
		table.insert(global.turrets, turret)
	end
	register_buildings()
	for _, turret in pairs(global.turrets) do
		turret.insert{name="dota-rocket", count = 1000}
		turret.minable = false
		turret.operable = false
	end
	local silos = game.surfaces[1].find_entities_filtered{name = "dota-silo"}
	for _, silo in pairs(silos) do
		silo.minable = false
	end
	local radars = game.surfaces[1].find_entities_filtered{name = "dota-radar"}
	for _, radar in pairs(silos) do
		radar.minable = false
	end
	for _, recipe in pairs(game.forces["red"].recipes) do
		recipe.enabled = true
	end
	for _, recipe in pairs(game.forces["blue"].recipes) do
		recipe.enabled = true
	end
	global.initialized = true
	global.start_tick = nil
	global.on_tick = {}
	global.units = {}
	global.players = {}
	global.lobbys = {}
	global.eq_gui_clicks = {}
	global.lobby_teams = {red = {}, blue = {}, unassigned = {}}
	global.initializing_force = false
	game.create_force("wildlings")
	game.forces["red"].set_cease_fire(game.forces["wildlings"], true)
	game.forces["wildlings"].set_cease_fire(game.forces["red"], true)
	game.forces["blue"].set_cease_fire(game.forces["wildlings"], true)
	game.forces["wildlings"].set_cease_fire(game.forces["blue"], true)
	local spawners = game.surfaces[1].find_entities_filtered{name = {"biter-spawner", "spitter-spawner"}}
	for _, spawner in pairs(spawners) do
		local loc = spawner.position
		local name = spawner.name
		spawner.destroy()
		game.surfaces[1].create_entity{name="dota-biter-spawner", position = loc, force = "wildlings"}
		
	end
	local enemies = game.surfaces[1].find_entities_filtered{force = "enemy"}
	for _, enemy in pairs(enemies) do
		enemy.force = "wildlings"
	end
	for _, player in pairs(game.players) do
		create_lobby(player)
	end
	local trees = game.surfaces[1].find_entities_filtered{type="tree"}
	for _, tree in pairs(trees) do
		if tree.name:sub(1,9) ~= "dotatree-" then
			local color = tree.tree_color_index 
			local variation = tree.graphics_variation
			local position = tree.position
			local name = "dotatree-"..tree.name
			tree.destroy()
			local newtree = game.surfaces[1].create_entity{name = name, position = position}
			newtree.graphics_variation = variation
			newtree.tree_color_index = color
		end
	end
	local blue_buildings = game.surfaces[1].find_entities_filtered{area={{x=201,y=-501},{x=501,y=-201}}, force = "player"}
	local red_buildings = game.surfaces[1].find_entities_filtered{area={{x=-501,y=201},{x=-201,y=501}}, force = "player"}
	for _, building in pairs(blue_buildings) do
		if building.name == "electric-energy-interface" then
			building.force = "blue"
			if FREE_ENERGY == 0 then
				building.destroy()
			else
				building.power_production = FREE_ENERGY/60
				building.electric_buffer_size  = FREE_ENERGY/60
				building.operable = false
				building.minable = false
				building.destructible = false
			end
		elseif building.type ~="resource" then
			building.force = "blue"
			building.energy = 999999999999
		end
	end
	for _, building in pairs(red_buildings) do
		if building.name == "electric-energy-interface" then
			building.force = "red"
			if FREE_ENERGY == 0 then
				building.destroy()
			else
				building.power_production = FREE_ENERGY/60
				building.electric_buffer_size  = FREE_ENERGY/60
				building.operable = false
				building.minable = false
				building.destructible = false
			end
		elseif building.type ~="resource" then
			building.force = "red"
			building.energy = 999999999999
		end
	end
	game.forces["red"].share_chart = true
	game.forces["red"].ghost_time_to_live  = 216000
	game.forces["blue"].share_chart = true
	game.forces["blue"].ghost_time_to_live  = 216000
end

function on_player_created(player)
	if not global.initialized and player.character then
		init()
	end
	
	if not global.players[player.index] then
		local loc = player.surface.find_non_colliding_position("character", {x=-303,y=-286}, 25,0.1)
		player.teleport(loc)
		if global.lobbys[player.index] then
			global.lobbys[player.index].destroy()
		end
		if global.countdown and global.countdown <= 0 then
			straggler_gui(player)
			talents_gui(player)
		else
			create_lobby(player)
			talents_gui(player)
		end
		for _, recipe in pairs(player.force.recipes) do
			recipe.enabled = false
		end
		if remote.interfaces["spell-pack"] then
			local players =remote.call("spell-pack","get","players")
			players[player.index].spirit_per_kill = 0
			players[player.index].mana_reg = 0.5
			remote.call("spell-pack","set","players",players)
		end
	end
end

script.on_event(defines.events.on_player_created, function(event)
	if not global.on_tick[event.tick + 1] then global.on_tick[event.tick + 1] = {} end
	local player = game.players[event.player_index]
	table.insert(global.on_tick[event.tick + 1], function () on_player_created(player) end)
	if global.updaterecipes then
		updatergui(player)
	end
end)

script.on_nth_tick(61, function(event)
	if not global.start_tick or event.tick < global.start_tick+1800 then return end
	if event.tick % 1830 > 361 then return end
	local silo1 = global.silos[1]
	local silo2 = global.silos[2]
	if not silo1 or not silo2 or not silo1.valid or not silo2.valid then return end
	local level = math.floor((game.tick - global.start_tick) / TICKS_PER_LEVEL)+1
	make_units("red", level)
	make_units("blue", level)
end)

script.on_nth_tick(1500, function(event)
	if not global.start_tick then return end
	for _, unit in pairs(global.turrets) do
		if unit and unit.valid then
			unit.insert{name="dota-rocket", count = 1000}
		end
	end
	game.forces["red"].set_turret_attack_modifier("dota-rocket-red",  math.floor((event.tick - global.start_tick)/TICKS_PER_LEVEL)/2)
	game.forces["blue"].set_turret_attack_modifier("dota-rocket-blue", math.floor((event.tick - global.start_tick)/TICKS_PER_LEVEL)/2)
	--for i, unit in pairs(global.units) do
	--	if unit.valid then
	--		if not unit.moving then
	--			unit.destroy()
	--			global.units[i] = nil
	--		end
	--	else
	--		global.units[i] = nil
	--	end
	--end
end)
		
--	end
--end)
function make_units(color, level)
	local def = defines
	local compound = def.command.compound
	local structure = def.compound_command.return_last
	local go_to = def.command.go_to_location
	local attack = def.command.attack
	local attack_area = def.command.attack_area
	local silo_pos = global.buildings[color].silo.entity.position
	local north_spawn
	local middle_spawn
	local south_spawn
	if color == "red" then
		local enemy_silo_pos = global.buildings.blue.silo.entity.position
		local north_level = level
		local middle_level = level
		local south_level = level
		if not global.buildings.blue.radars[1] and math.random() <0.17 then
			north_level = north_level + 10
		end
		if not global.buildings.blue.radars[2] and math.random() <0.17 then
			middle_level = middle_level + 10
		end
		if not global.buildings.blue.radars[3] and math.random() <0.17 then
			south_level = south_level + 10
		end
		local north_spawn = game.surfaces[1].find_non_colliding_position("dota-biter-"..north_level.."-"..color,{x= silo_pos.x, y = silo_pos.y - 10}, 10,0.2)
		local middle_spawn = game.surfaces[1].find_non_colliding_position("dota-biter-"..middle_level.."-"..color,{x= silo_pos.x+10, y = silo_pos.y - 10}, 10,0.2)
		local south_spawn = game.surfaces[1].find_non_colliding_position("dota-biter-"..south_level.."-"..color,{x= silo_pos.x+10, y = silo_pos.y}, 10,0.2)
		local north_biter = game.surfaces[1].create_entity{name="dota-biter-"..north_level.."-"..color, position = north_spawn, force = color}
		north_biter.ai_settings.allow_destroy_when_commands_fail = true
		north_biter.ai_settings.do_separation = true
		local middle_biter = game.surfaces[1].create_entity{name="dota-biter-"..middle_level.."-"..color, position = middle_spawn, force = color}
		middle_biter.ai_settings.allow_destroy_when_commands_fail = true
		middle_biter.ai_settings.do_separation = true
		local south_biter = game.surfaces[1].create_entity{name="dota-biter-"..south_level.."-"..color, position = south_spawn, force = color}
		south_biter.ai_settings.allow_destroy_when_commands_fail = true
		south_biter.ai_settings.do_separation = true
		north_biter.set_command{
			type = compound,
			structure_type = structure,
			commands =
			{
				{type = go_to, destination = {x=-181 ,y=131}},
				{type = go_to, destination = {x=-125 ,y=-183}},
				--{type = go_to, destination = enemy_silo_pos},
				--{type = attack, target = silo2}
				{type = attack_area, destination = enemy_silo_pos, radius = 70}
			}
		}
		table.insert(global.units, north_biter)
		south_biter.set_command{
			type = compound,
			structure_type = structure,
			commands =
			{
				{type = go_to, destination = {x=118 ,y=170}},
				{type = go_to, destination = {x=177 ,y=115}},
				--{type = go_to, destination = enemy_silo_pos},
				--{type = attack, target = silo2}
				{type = attack_area, destination = enemy_silo_pos, radius = 70}
			}
		}
		table.insert(global.units, south_biter)
		middle_biter.set_command{
			type = compound,
			structure_type = structure,
			commands =
			{
				--{type = go_to, destination = {x=118 ,y=170}},
				--{type = go_to, destination = {x=177 ,y=115}},
				--{type = go_to, destination = enemy_silo_pos},
				--{type = attack, target = silo2}
				{type = attack_area, destination = enemy_silo_pos, radius = 70}
			}
		}
		table.insert(global.units, middle_biter)
	elseif color == "blue" then
		local north_level = level
		local middle_level = level
		local south_level = level
		if not global.buildings.red.radars[1] and math.random() <0.17 then
			north_level = north_level + 10
		end
		if not global.buildings.red.radars[2] and math.random() <0.17 then
			middle_level = middle_level + 10
		end
		if not global.buildings.red.radars[3] and math.random() <0.17 then
			south_level = south_level + 10
		end
		local enemy_silo_pos = global.buildings.red.silo.entity.position
		local north_spawn = game.surfaces[1].find_non_colliding_position("dota-biter-"..north_level.."-"..color,{x= silo_pos.x-10, y = silo_pos.y}, 10,0.2)
		local middle_spawn = game.surfaces[1].find_non_colliding_position("dota-biter-"..middle_level.."-"..color,{x= silo_pos.x-10, y = silo_pos.y + 10}, 10,0.2)
		local south_spawn = game.surfaces[1].find_non_colliding_position("dota-biter-"..south_level.."-"..color,{x= silo_pos.x, y = silo_pos.y+10}, 10,0.2)
		
		local north_biter = game.surfaces[1].create_entity{name="dota-biter-"..north_level.."-"..color, position = north_spawn, force = color}
		north_biter.ai_settings.allow_destroy_when_commands_fail = true
		north_biter.ai_settings.do_separation = true
		local middle_biter = game.surfaces[1].create_entity{name="dota-biter-"..middle_level.."-"..color, position = middle_spawn, force = color}
		middle_biter.ai_settings.allow_destroy_when_commands_fail = true
		middle_biter.ai_settings.do_separation = true
		local south_biter = game.surfaces[1].create_entity{name="dota-biter-"..south_level.."-"..color, position = south_spawn, force = color}
		south_biter.ai_settings.allow_destroy_when_commands_fail = true
		south_biter.ai_settings.do_separation = true
		north_biter.set_command{
			type = compound,
			structure_type = structure,
			commands =
			{
				{type = go_to, destination = {x=-125 ,y=-183}},
				{type = go_to, destination = {x=-181 ,y=131}},
				--{type = go_to, destination = enemy_silo_pos},
				--{type = attack, target = silo2}
				{type = attack_area, destination = enemy_silo_pos, radius = 70}
			}
		}
		table.insert(global.units, north_biter)
		south_biter.set_command{
			type = compound,
			structure_type = structure,
			commands =
			{
				{type = go_to, destination = {x=177 ,y=115}},
				{type = go_to, destination = {x=118 ,y=170}},
				--{type = go_to, destination = enemy_silo_pos},
				--{type = attack, target = silo2}
				{type = attack_area, destination =enemy_silo_pos, radius = 70}
			}
		}
		table.insert(global.units, south_biter)
		middle_biter.set_command{
			type = compound,
			structure_type = structure,
			commands =
			{
				--{type = go_to, destination = {x=118 ,y=170}},
				--{type = go_to, destination = {x=177 ,y=115}},
				--{type = go_to, destination = enemy_silo_pos},
				--{type = attack, target = silo2}
				{type = attack_area, destination = enemy_silo_pos, radius = 70}
			}
		}
		table.insert(global.units, middle_biter)
	end
end

function insert_items(entity, array)
	for name, count in pairs (array) do
		entity.insert({name = name, count = count})
	end
end
--script.on_event(defines.events.on_console_chat, function(event)
--if event.message == "gold" then
--global.players[event.player_index].money = 10000
--game.print(global.players[event.player_index].bonuses.reflect)
--end
--end)
function create_player(player, force)
	--force = force..(#global.players[force])
	--global.players[force][player.index] = {}
	game.create_force("player-"..player.index)
	player.force = "player-"..player.index
	if force == "red" then
		player.color = {r=1,g=0,b=0}
	else
		player.color = {r=0,g=0,b=1}
	end
	local copyforce
	local copyforce_id
	for id, data in pairs(global.players) do
		if data.color == force then
			copyforce = data.force
			copyforce_id = id
		end
	end
	global.players[player.index] = {force = player.force, color = force, research = {}, money = 200,bonuses = {income = 1, crit = 0, critdamage = 0, armor = 0, reflect = 0, regen = 1.5, chardamage = 0, chardamage_mult = 1}, giveitem={}, giveitem_cache = {}, modifiers = {},talent_modifiers = {}, items = {}, item_cooldowns = {}}
	for id, pl in pairs(global.players) do
		if pl.color == force then
			pl.force.set_friend(player.force, true)
			player.force.set_friend(pl.force, true)
		end
	end
	--player.force.set_cease_fire(force, true)
	player.force.set_friend(force, true)
	--game.forces[force].set_cease_fire(player.force, true)
	game.forces[force].set_friend(player.force, true)
	if global.players[player.index].color =="red" then
		local loc = player.surface.find_non_colliding_position("character", {x=-194,y=194}, 15,0.1)
		player.teleport(loc)
	else
		local loc = player.surface.find_non_colliding_position("character",{x=194,y=-194}, 15,0.1)
		player.teleport(loc)
	end
	global.researching = true
	if not copyforce then
		for _, tech in pairs(player.force.technologies) do
			local modifier = false
			for name, mod in pairs(tech.effects) do 
				if mod.type == "gun-speed" or mod.type == "ammo-damage" or mod.type == "turret-attack" or mod.type == "artillery-range" then
					modifier = true
				end
			end
			if not modifier and tech.name ~= "artillery" then tech.researched = true end
		end
	else
		for _, technology in pairs(player.force.technologies) do
			if copyforce.technologies[technology.name].researched then
				technology.researched = true
			elseif copyforce.technologies[technology.name].level > 1 then
				technology.level = copyforce.technologies[technology.name].level
				set_progress(player.force, technology.name, get_progress(copyforce, technology))
				global.players[player.index].research[technology.name] = (get_progress(copyforce, technology) or 0)
			else
				set_progress(player.force, technology.name, get_progress(copyforce, technology))
				global.players[player.index].research[technology.name] = (get_progress(copyforce, technology) or 0)
			end
		end
		if copyforce.current_research then
			player.force.research_queue ={copyforce.current_research.name}
		end
	end
	player.force.set_saved_technology_progress("artillery", 0.25)
	global.researching = false
	player.force.recipes["rocket-launcher"].enabled = false
	player.force.recipes["dota-rocket-launcher"].enabled = true
	player.force.recipes["light-armor"].enabled = false
	player.force.recipes["dotaarmor-light-armor"].enabled = true
	player.force.recipes["heavy-armor"].enabled = false
	player.force.recipes["dotaarmor-heavy-armor"].enabled = true
	if player.force.recipes["dota-market"] then
		player.force.recipes["dota-market"].enabled = false
	end
	player.character_crafting_speed_modifier = player.character_crafting_speed_modifier + BONUS_CRAFTING_SPEED
	create_equipment_gui(player)
	give_spawn_equipment(player)
	give_starting_equipment(player)
	player.force.share_chart = true
	if copyforce_id and remote.interfaces["spell-pack"] then
		local players =remote.call("spell-pack","get","players")
		players[player.index].spirit = players[copyforce_id].spirit
		remote.call("spell-pack","set","players",players)
	end
	apply_talents(player)
end



script.on_configuration_changed(function()

end)
script.on_event(defines.events.on_tick, function(event)
	if global.updaterecipes and not global.pauseupdate then

		local donesomething = false
		for name, proto in pairs(game.recipe_prototypes) do
			if donesomething then
				for _, player in pairs(game.players) do
					player.gui.top.dotamarket_updater.numberflow.current.caption = (proto and proto.localised_name) or "nil"
					player.gui.top.dotamarket_updater.numberflow.total.caption = global.updateprogress.."/"..global.totalrecipes
					player.gui.top.dotamarket_updater.bar.value = global.updateprogress / global.totalrecipes
				end
				break
			end

			if not global.recipes[name] then
				local results = rawingredients(proto)
				local intermediates = results.intermediates
				results.intermediates = nil
				local error
				if results.ERROR_INFINITE_LOOP then
					game.print("infinite loop: "..name)
					error=true
				end
				global.recipes[name] = {products = getProducts(proto), raw = results, intermediates = intermediates or {}, error = error}
				donesomething = true
				global.updateprogress = global.updateprogress + 1
			end
		end
		if not donesomething then
			global.updaterecipes = false
			for _, player in pairs(game.players) do
				player.gui.top.dotamarket_updater.destroy()
			end
			create_database()
		end
	end
	--for i in pairs(global.clean_cursor) do
	--	game.players[i].clean_cursor()
	--	global.clean_cursor[i] = nil
	--end
	if global.on_tick[event.tick] then
		for _, func in pairs(global.on_tick[event.tick]) do
			func()
		end
		global.on_tick[event.tick]=nil
	end
end)


script.on_event(defines.events.on_player_died, function(event)
	if not global.players[event.player_index] then return end
	local player = game.players[event.player_index]
	local corpse = player.surface.find_entity("character-corpse", player.position)
	local displayed_corpse = player.surface.create_entity{name="character-corpse", force=player.force, position = player.position, player = player}
	displayed_corpse.character_corpse_player_index = corpse.character_corpse_player_index 
	displayed_corpse.character_corpse_tick_of_death = corpse.character_corpse_tick_of_death  
	displayed_corpse.character_corpse_death_cause  = corpse.character_corpse_death_cause   
	global.players[player.index].corpse = corpse
	local loc = player.surface.find_non_colliding_position("character", {x=290,y=305}, 15,0.1)
	corpse.teleport(loc)
	player.ticks_to_respawn = 600 + (event.tick-global.start_tick)/120
	--print((event.tick-global.start_tick)/120)
	--player.teleport(loc)
end)

script.on_event(defines.events.on_player_respawned, function(event)
	if not global.players[event.player_index] then return end
	local player = game.players[event.player_index]
	if global.players[event.player_index].color =="red" then
		local loc = player.surface.find_non_colliding_position("character", {x=-194,y=194}, 15,0.1)
		player.teleport(loc)
	else
		local loc = player.surface.find_non_colliding_position("character",{x=194,y=-194}, 15,0.1)
		player.teleport(loc)
	end
	player.get_inventory(defines.inventory.character_ammo).clear()
	player.get_inventory(defines.inventory.character_guns).clear()
	player.get_main_inventory().clear()
	local corpse_inv = global.players[event.player_index].corpse.get_inventory(defines.inventory.character_corpse)
	for i=1, #corpse_inv do
		player.insert(corpse_inv[i])
		corpse_inv[i].clear()
	end
	for i=1, #corpse_inv do
		player.insert(corpse_inv[i])
		corpse_inv[i].clear()
	end
end)

script.on_nth_tick(6, function(event)
	if not global.players then return end
	for id, data in pairs(global.players) do
		local character = game.players[id].character
		if character then
			character.health = character.health + data.bonuses.regen/10
		end
	end
end)

script.on_nth_tick(60, function(event)
	if global.countdown and global.countdown >-30 then
		global.countdown = global.countdown -1
		if global.countdown > 0 then
			game.print("Game starts in "..global.countdown)
		elseif global.countdown == 0 then
			game.print("Game started")
			global.start_tick = event.tick
			for id,_ in pairs(global.lobby_teams.red) do
				if global.lobbys[id] then
					global.lobbys[id].destroy()
					global.lobbys[id]=nil
				end
				create_player(game.players[id], "red")
			end
			for id in pairs(global.lobby_teams.blue) do
				if global.lobbys[id] then
					global.lobbys[id].destroy()
					global.lobbys[id]=nil
				end
				create_player(game.players[id], "blue")
			end
			for id in pairs(global.lobby_teams.unassigned) do
				if global.lobbys[id] then
					global.lobbys[id].destroy()
					global.lobbys[id]=nil
				end
			end
		end
	end
	if not global.players or table_length(global.players) == 0 then return end
	for id, data in pairs(global.players) do
		if data.force.current_research then
			--print(data.force.name)
			--print(data.force.get_saved_technology_progress(data.force.current_research))
			--if (data.force.get_saved_technology_progress(data.force.current_research) or 0) > (data.research[data.force.current_research.name] or 0) then
			if get_progress(data.force,data.force.current_research) > (data.research[data.force.current_research.name] or 0) then
				--local added_progress = (data.force.get_saved_technology_progress(data.force.current_research) or 0)-(data.research[data.force.current_research.name] or 0)
				local added_progress = get_progress(data.force,data.force.current_research)-(data.research[data.force.current_research.name] or 0)
				data.research[data.force.current_research.name] = (data.research[data.force.current_research.name] or 0) + added_progress
				for id2, data2 in pairs(global.players) do
					if data2.color == data.color and data2.force.name ~= data.force.name then
						data2.research[data.force.current_research.name] = (data2.research[data.force.current_research.name] or 0) + added_progress
						set_progress(data2.force, data.force.current_research.name, get_progress(data2.force,data.force.current_research) + added_progress)
					end
				end
			end
		end
	end
	for id, data in pairs(global.players) do
		--income
		local player = game.players[id]
		data.money = data.money + data.bonuses.income
		player.gui.left.dota_item_gui.money.caption = math.floor(global.players[id].money).."[img=dota-coin]"
		--cooldowns
		local update = false
		for field, cd in pairs(data.item_cooldowns) do
			cd = cd -1
			if cd <= 0 then
				cd = nil
			end
			data.item_cooldowns[field] = cd
			update = true
		end
		if update then
			update_items(game.players[id])
		end
		--giveitem
		if player.character and player.character.valid then
			for item, persec in pairs(data.giveitem) do
				data.giveitem_cache[item] = (data.giveitem_cache[item] or 0) + persec
				if data.giveitem_cache[item] >= 1 then
					local inserted = player.insert{name=item, count = math.floor(data.giveitem_cache[item])}
					data.giveitem_cache[item] = data.giveitem_cache[item] - inserted
				end
			end
		end
	end
end)
function get_progress(force, research)
	local research_name = research
	if type(research_name) ~= "string" then
		research_name = research.name
	end
	if force.current_research and force.current_research.name == research_name then
		return force.research_progress
	else
		return force.get_saved_technology_progress(research_name) or 0
	end
end

function set_progress(force, research, value)
	local research_name = research
	if type(research_name) ~= "string" then
		research_name = research.name
	end
	if value >=1 then
		force.technologies[research_name].researched = true
	else
		if force.current_research and force.current_research.name == research_name then
			force.research_progress = value
		else
			force.set_saved_technology_progress(research_name, value)
		end
	end
end
script.on_event(defines.events.on_research_finished, function(event)
	if global.researching then return end
	local research = event.research
	local force_id = tonumber(event.research.force.name:sub(8))
	--game.players[force_id].print(global.stackoverflow[event.tick]..event.research.name)
	if not global.players[force_id] then return end
	global.researching = true
	for id, data in pairs(global.players) do
		if data.color == global.players[force_id].color then
			data.research[research.name] =0
			if data.force.name ~=research.force.name and not data.force.technologies[research.name].researched then
				data.force.technologies[research.name].researched = true
			end
		end
	end
	global.researching = false
end)
function table_length(tbl)
	local i=0
	for _ in pairs(tbl) do
		i=i+1
	end
	return i
end

function dbg(str)
	if str == nil then
		str = "nil"
	elseif type(str) ~= "string" and type(str) ~= "number" then
		if type(str)=="boolean" then
			if str == true then
				str = "true"
			else
				str = "false" 
			end
		else
			str=type(str)
		end
	end
	game.players[1].print(game.tick.. " "..str)
end

function distance(pos1,pos2)
	local x=(pos1.x-pos2.x)^2
	local y=(pos1.y-pos2.y)^2
	return(x+y)^0.5
end

function print(str)
game.players[1].print(str)
end

script.on_event({defines.events.on_robot_built_entity,defines.events.on_built_entity}, function(event)

end)
script.on_event(defines.events.on_gui_opened, function(event)
	if not event.entity  then return end
	if event.entity.name =="dota-market" then
		local player = game.players[event.player_index]
		open_market(player)
		unlock_items(player)
	end
	if event.entity.name =="dota-item-market" then
		local player = game.players[event.player_index]
		local gui = player.gui.center.add{type="frame", name = "dota_item_market", direction = "vertical"}
		itemselector_gui(gui, player)
		player.opened = gui
	end
end)
script.on_event(defines.events.script_raised_built, function()

end)


script.on_event(defines.events.on_trigger_created_entity, function(event)
	if not event.entity then return end
	
end)
script.on_event(defines.events.on_gui_closed, function(event)
	if event.element and event.element.name =="dota_market" then
		event.element.destroy()
		lock_items(game.players[event.player_index])
	elseif event.element and event.element.name == "dota_item_market" then
		event.element.destroy()
	
	end
end)

script.on_event(defines.events.on_entity_died, function(event)
	if not event.force then return end
	if event.force.name:sub(1,7) =="player-" and not event.force.get_friend(event.entity.force.name) and not event.force.get_cease_fire(event.entity.force.name) then
		local player_id = tonumber(event.force.name:sub(8))
		if event.entity.name == "character" then
			global.players[player_id].money = global.players[player_id].money + 100
			event.entity.surface.create_entity{name= "flying-text", color = {r=0,g=0.7,b=0}, position = event.entity.position, render_player_index = player_id, text = "+100"}
		elseif event.entity.name:sub(1,5) == "dota-" then
			global.players[player_id].money = global.players[player_id].money + 10
			event.entity.surface.create_entity{name= "flying-text", color = {r=0,g=0.7,b=0}, position = event.entity.position, render_player_index = player_id, text = "+10"}
			if remote.interfaces["spell-pack"] then
				local players =remote.call("spell-pack","get","players")
				local color = global.players[player_id].color
				for id, player in pairs(global.players) do
					if player.color ==color then
						players[id].spirit = math.min(players[id].max_spirit,players[id].spirit + 0.5)
					end
				end
				remote.call("spell-pack","set","players",players)
			end
		end
	end
	if event.entity.name:sub(1,12) == "dota-rocket-" then
		local color = event.entity.name:sub(13)
		local playercount = 0
		for _, player in pairs(global.players) do
			if player.color ~=color then
				playercount = playercount + 1
			end
		end
		for player_id, player in pairs(global.players) do
			if player.color ~=color then
				global.players[player_id].money = global.players[player_id].money + math.floor(400/playercount)
				game.players[player_id].print("Your Team has destroyed a turret. +"..math.floor(400/playercount).." Gold")
				
			end
		end
		if event.entity == global.buildings[color].west_towers[#global.buildings[color].west_towers] then
			global.buildings[color].west_towers[#global.buildings[color].west_towers] = nil
			if #global.buildings[color].west_towers == 0 then
				global.buildings[color].radars[1].destructible = true
			else
				global.buildings[color].west_towers[#global.buildings[color].west_towers].destructible = true
			end
		elseif event.entity == global.buildings[color].middle_towers[#global.buildings[color].middle_towers] then
			global.buildings[color].middle_towers[#global.buildings[color].middle_towers] = nil
			if #global.buildings[color].middle_towers == 0 then
				global.buildings[color].radars[2].destructible = true
			else
				global.buildings[color].middle_towers[#global.buildings[color].middle_towers].destructible = true
			end
		elseif event.entity == global.buildings[color].south_towers[#global.buildings[color].south_towers] then
			global.buildings[color].south_towers[#global.buildings[color].south_towers] = nil
			if #global.buildings[color].south_towers == 0 then
				global.buildings[color].radars[3].destructible = true
			else
				global.buildings[color].south_towers[#global.buildings[color].south_towers].destructible = true
			end
		elseif event.entity == global.buildings[color].base_towers[1] then
			global.buildings[color].base_towers[1] = nil
			if table_length(global.buildings[color].base_towers) == 0 then
				global.buildings[color].silo.destructible = true
			end
		elseif event.entity == global.buildings[color].base_towers[2] then
			global.buildings[color].base_towers[2] = nil
			if table_length(global.buildings[color].base_towers) == 0 then
				global.buildings[color].silo.destructible = true
			end
		end
	elseif event.entity.name == "dota-radar" then
		local color = event.entity.force.name
		local playercount = 0
		for _, player in pairs(global.players) do
			if player.color ~=color then
				playercount = playercount + 1
			end
		end
		for player_id, player in pairs(global.players) do
			if player.color ~=color then
				global.players[player_id].money = global.players[player_id].money + math.floor(150/playercount)
				game.players[player_id].print("Your Team has destroyed a radar. +"..math.floor(150/playercount).." Gold")
				
			end
		end
		for i=1, 3 do
			if global.buildings[color].radars[i] == event.entity then
				local pos = event.entity.position
				local force = color
				if not global.on_tick[game.tick + 18000] then global.on_tick[game.tick + 18000] = {} end
				table.insert(global.on_tick[game.tick + 18000], function ()
					global.buildings[force].radars[i] = game.surfaces[1].create_entity{name = "dota-radar", position = pos, force = force}
					if global.buildings[force].base_towers[1] then
						global.buildings[force].base_towers[1].destructible = false
					end
					if global.buildings[force].base_towers[2] then
						global.buildings[force].base_towers[2].destructible = false
					end
					if global.buildings[force].silo then
						global.buildings[force].silo.destructible = false
					end
				end)
				global.buildings[color].radars[i] = nil
				if table_length(global.buildings[color].radars) == 0 then
					if table_length(global.buildings[color].base_towers) == 0 then
						global.buildings[force].silo.destructible = true
					else
						if global.buildings[force].base_towers[1] then
							global.buildings[force].base_towers[1].destructible = true
						end
						if global.buildings[force].base_towers[2] then
							global.buildings[force].base_towers[2].destructible = true
						end
					end
				end
			end
		end
	end
end)

script.on_event(defines.events.on_entity_damaged, function(event)
--print("orig: "..event.original_damage_amount)
--print("final: "..event.final_damage_amount )
if event.entity and event.entity.name == "character" and event.entity.health >0 then
	local player = event.entity.player
	if event.cause and global.players[player.index].bonuses.reflect > 0 then
		event.cause.damage(global.players[player.index].bonuses.reflect, event.entity.force, event.damage_type.name)
	end
	--if event.damage_type.name:sub(1,4)=="osp_" then
	--	local mres = global.players[player.index].bonuses.magic_resistance /(global.players[player.index].bonuses.magic_resistance+100)
	--	event.entity.health = event.entity.health + event.final_damage_amount*mres	
	--else
		local armor = global.players[player.index].bonuses.armor /(global.players[player.index].bonuses.armor+100)
		event.entity.health = event.entity.health + event.final_damage_amount*armor
	--end
end
if event.cause and event.cause.valid and event.cause.name == "character" then
	if event.entity.force.get_friend(event.cause.force) then
		event.entity.health = event.entity.health + event.final_damage_amount
	elseif event.entity.name == "dota-silo" and not global.buildings[event.entity.force.name].silo.destructible then
		event.entity.health = event.entity.health + event.final_damage_amount
	else
		local player = event.cause.player
		if event.entity.name == "character" then
			local enemy_force = "red"
			local pos = event.cause.position
			if global.players[player.index].color == "red" then
				enemy_force = "blue"
			end
			local towers = game.surfaces[1].find_entities_filtered{name="dota-rocket-"..enemy_force,area ={{pos.x-22,pos.y-22},{pos.x+22,pos.y+22}}}
			if towers[1] and towers[1].valid and (not towers[1].shooting_target or towers[1].shooting_target.name ~= "character") and distance(towers[1].position, pos) <= 20 then
				towers[1].shooting_target = event.cause
			end
		end
		if event.entity.valid then
			local extradamage = 0
			if event.damage_type.name == "chardamage" then
				extradamage = global.players[player.index].bonuses.chardamage*global.players[player.index].bonuses.chardamage_mult + (global.players[player.index].bonuses.chardamage_mult-1)*8
				event.entity.damage(extradamage, event.cause.force, "physical")
			end
			if event.entity.valid and event.entity.has_flag("breaths-air") and math.random() < global.players[player.index].bonuses.crit then
				local pos =  event.entity.position
				local surface = event.entity.surface
				--local player_mult = 1
				--if event.
				local dmg = event.entity.damage((event.final_damage_amount+extradamage)*(1+global.players[player.index].bonuses.critdamage), event.cause.force, event.damage_type.name)
				dmg = dmg + event.final_damage_amount
				surface.create_entity{name="flying-text", position = pos, color = {r=1,g=0,b=0}, text = math.floor(dmg), render_player_index = player.index}
			end
		end
	end

end
end)

script.on_event({defines.events.on_robot_built_entity,defines.events.on_built_entity}, function(event)
	if event.created_entity.name == "stone-wall" or event.created_entity.name == "gate" then
		local player_id = tonumber(event.created_entity.force.name:sub(8))
		event.created_entity.force = global.players[player_id].color
	end
end)

script.on_event(defines.events.on_research_started, function(event)
	if not global.initialized then return end
	local player_id = tonumber(event.research.force.name:sub(8))
	if not global.players[player_id] then return end
	local color = global.players[player_id].color
	for id, playerdata in pairs(global.players) do
		if id ~= player_id and playerdata.color ==color and (not playerdata.force.current_research or playerdata.force.current_research.name ~=event.research.name) then
			playerdata.force.research_queue ={event.research.name}
		end
	end
end)