function sort_towers(towers, axis, mode)
	local temp_towers = {}
	for i=1, #towers do
		--local x = -999999
		local pos
		if mode == "<" then
			pos = 999999
		else
			pos = -999999
		end
		local id 
		for i, tower in pairs(towers) do
			if mode == "<" then
				if tower.position[axis] < pos then
					--x = tower.position.x
					pos = tower.position[axis]
					id = i
				end
			else
				if tower.position[axis] > pos then
					--x = tower.position.x
					pos = tower.position[axis]
					id = i
				end
			end
		end
		table.insert(temp_towers, towers[id])
		table.remove(towers, id)
	end
	return temp_towers
end

function register_buildings()
	local red_towers = game.surfaces[1].find_entities_filtered{force = "red", name="dota-rocket-red"}
	local red_towers_base = {}
	local blue_towers = game.surfaces[1].find_entities_filtered{force = "blue", name="dota-rocket-blue"}
	local blue_towers_base = {}
	for t=1, 2 do
		local pos = 999999
		--local y = 999999
		local id 
		for i, tower in pairs(red_towers) do
			if tower.position.x-tower.position.y < pos then
			--if tower.position.x < x and tower.position.y < y then
				pos = tower.position.x-tower.position.y
				id = i
			end
		end
		table.insert(red_towers_base, red_towers[id])
		table.remove(red_towers, id)
	end
	local red_towers_south = {}
	for t=1, 3 do
		--local x = -999999
		local y = -999999
		local id 
		for i, tower in pairs(red_towers) do
			if tower.position.y > y then
				--x = tower.position.x
				y = tower.position.y
				id = i
			end
		end
		table.insert(red_towers_south, red_towers[id])
		table.remove(red_towers, id)
	end
	red_towers_south = sort_towers(red_towers_south, "x", "<")
	local red_towers_west = {}
	for t=1, 3 do
		local x = 999999
		--local y = -999999
		local id 
		for i, tower in pairs(red_towers) do
			if tower.position.x <= x then
				--x = tower.position.x
				x = tower.position.x
				id = i
			end
		end
		table.insert(red_towers_west, red_towers[id])
		table.remove(red_towers, id)
	end
	red_towers_west = sort_towers(red_towers_west, "y", ">")
	local red_towers_middle = sort_towers(red_towers, "y", ">")
	
	
	for t=1, 2 do
		local pos = -999999
		--local y = 999999
		local id 
		for i, tower in pairs(blue_towers) do
			if tower.position.x-tower.position.y > pos then
				pos = tower.position.x-tower.position.y
				id = i
			end
		end
		table.insert(blue_towers_base, blue_towers[id])
		table.remove(blue_towers, id)
	end
	local blue_towers_south = {}
	for t=1, 3 do
		--local x = -999999
		local x = -999999
		local id 
		for i, tower in pairs(blue_towers) do
			if tower.position.x >= x then
				--x = tower.position.x
				x = tower.position.x
				id = i
			end
		end
		table.insert(blue_towers_south, blue_towers[id])
		table.remove(blue_towers, id)
	end
	blue_towers_south = sort_towers(blue_towers_south, "y", "<")
	local blue_towers_west = {}
	for t=1, 3 do
		local y = 999999
		--local y = -999999
		local id 
		for i, tower in pairs(blue_towers) do
			if tower.position.y <= y then
				--x = tower.position.x
				y = tower.position.y
				id = i
			end
		end
		table.insert(blue_towers_west, blue_towers[id])
		table.remove(blue_towers, id)
	end
	blue_towers_west = sort_towers(blue_towers_west, "x", ">")
	local blue_towers_middle = sort_towers(blue_towers, "y", "<")

	local red_radars = game.surfaces[1].find_entities_filtered{force = "red", name="dota-radar"}
	red_radars = sort_towers(red_radars, "y", "<")
	
	local blue_radars = game.surfaces[1].find_entities_filtered{force = "blue", name="dota-radar"}
	blue_radars = sort_towers(blue_radars, "y", "<")
	
	
	local red_silo = game.surfaces[1].find_entities_filtered{force = "red", name="dota-silo"}
	red_silo={entity = red_silo[1], destructible = false}
	local blue_silo = game.surfaces[1].find_entities_filtered{force = "blue", name="dota-silo"}
	blue_silo = {entity = blue_silo[1], destructible = false}
	global.buildings= {red={silo = red_silo, base_towers = red_towers_base, radars = red_radars, west_towers = red_towers_west, middle_towers = red_towers_middle, south_towers = red_towers_south}, blue={silo = blue_silo, base_towers = blue_towers_base, radars = blue_radars, west_towers = blue_towers_west, middle_towers = blue_towers_middle, south_towers = blue_towers_south}}
	red_towers_base[1].destructible = false
	red_towers_base[2].destructible = false
	red_towers_west[1].destructible = false
	red_towers_west[2].destructible = false
	red_towers_middle[1].destructible = false
	red_towers_middle[2].destructible = false
	red_towers_south[1].destructible = false
	red_towers_south[2].destructible = false
	red_radars[1].destructible = false
	red_radars[2].destructible = false
	red_radars[3].destructible = false
	--red_silo.destructible = false
	blue_towers_base[1].destructible = false
	blue_towers_base[2].destructible = false
	blue_towers_west[1].destructible = false
	blue_towers_west[2].destructible = false
	blue_towers_middle[1].destructible = false
	blue_towers_middle[2].destructible = false
	blue_towers_south[1].destructible = false
	blue_towers_south[2].destructible = false
	blue_radars[1].destructible = false
	blue_radars[2].destructible = false
	blue_radars[3].destructible = false
	--blue_silo.destructible = false
	--print("red south: "..#red_towers_south)
	--print("red west: "..#red_towers_west)
	--print("red middle: "..#red_towers_middle)
	--print("red base: "..#blue_towers_base)
	
end