require "json"
require "LibDeflate"
require "base64"


script.on_event(defines.events.on_gui_text_changed, function(event)
	if event.element.name == "dota_talents_copypaste" then
--		local player = game.players[event.player_index]
--		--local unbased,err = pcall(base64.decode,event.element.text)
--		local unbased = base64.decode(event.element.text)
--		game.print(unbased)
--		game.print(err)
--		if unbased then
--			--local decompressed = LibDeflate:DecompressZlib(err)
--			local decompressed = LibDeflate:DecompressZlib(unbased)
--			if decompressed then
--				--local talents_status, talents = pcall(decode,decompressed)
--				local talents =decode(decompressed)
--				if talents_status then
--					--global.talents[player.index] = talents
--					talents_gui(player)
--				else
--					player.print("JSON failed")
--				end
--			else
--				player.print("decompress failed")
--			end
--		else
--			player.print("base64 failed")
--		end
--
--		
--	--local talents_string = encode(global.talents[player.index])
--	--local compressed =  LibDeflate:CompressZlib(talents_string,{strategy="fixed"})
--	--local b64 = base64.encode( compressed)
--	--copypaste.text = b64
		local player = game.players[event.player_index]
		local unbased,unbased_ret = pcall(base64.decode,event.element.text)
		--local unbased = base64.decode(event.element.parent.dota_talents_copypaste.text)
		--local unbased =event.element.parent.dota_talents_copypaste.text
		if unbased then
			local decompressed,decompressed_ret = pcall(LibDeflate_DecompressZlib,unbased_ret)
			--local decompressed = LibDeflate:DecompressZlib(unbased)
			if decompressed then
				local talents_status, talents = pcall(decode,decompressed_ret)
				--local talents =decode(decompressed)
				--local talents =decode(unbased)
				if talents_status then
					global.talents[player.index] = talents
					talents_gui(player)
				else
					--player.print("JSON failed")
				end
			else
				player.print("decompress failed")
			end
		else
			player.print("base64 failed")
		end
	end
end)
function remove_margin_padding(elem)
		elem.style.top_margin = 0
		elem.style.right_margin = 0
		elem.style.left_margin = 0
		elem.style.bottom_margin = 0
		elem.style.top_padding = 0
		elem.style.right_padding = 0
		elem.style.left_padding = 0
		elem.style.bottom_padding = 0
end
function apply_talents(player)
	if not global.players[player.index] then return end
	if not global.talents[player.index].ready then return end
	for _, mod in pairs(global.players[player.index].talent_modifiers) do
		local mult = 1
		if mod.periodical then
			mult = mod.periodical
		end
		remove_modifier(player,mod,mult)
	end
	global.players[player.index].talent_modifiers = {}
	local talent_modifiers = {}
	for rgb, data in pairs(global.talents[player.index]) do
		if rgb ~="ready" then
		for id, amount in pairs(data) do
			local temp_mod = deepcopy(global.talents[rgb][id])
			if temp_mod.value then
				temp_mod.value = temp_mod.value * amount
			elseif temp_mod.per_second then
				temp_mod.per_second = temp_mod.per_second * amount
			end
			table.insert(talent_modifiers, temp_mod)
		end
		end
	end
	for _, modifier in pairs(talent_modifiers) do
		local mult = 1
		if modifier.periodical then
			mult = modifier.periodical
		end
		add_modifier(player,modifier,mult)
		table.insert(global.players[player.index].talent_modifiers, modifier)
	end
end
function talents_gui_click(event)
	if not event.element or not event.element.valid then return end
	if event.element.parent and event.element.parent.name:sub(1,19) == "dota_talent_choice_" then
		local player = game.players[event.player_index]
		if event.button == defines.mouse_button_type.left then
			if event.shift then
				for i=1, 5 do
					local verified_talents = verify_talents(player)
					if verified_talents[event.element.parent.name:sub(20,20)].spent>= 8 and verified_talents.total_spent >= 27 and verified_talents.a == 4 or verified_talents.total_spent >= 28 then
					else
						global.talents[event.player_index][event.element.parent.name:sub(20,20)][event.element.name] = (global.talents[event.player_index][event.element.parent.name:sub(20,20)][event.element.name] or 0) + 1
					end
					
				end
			else
				local verified_talents = verify_talents(player)
				if verified_talents[event.element.parent.name:sub(20,20)].spent>= 8 and verified_talents.total_spent >= 27 and verified_talents.a == 4 or verified_talents.total_spent >= 28 then
				else
					global.talents[event.player_index][event.element.parent.name:sub(20,20)][event.element.name] = (global.talents[event.player_index][event.element.parent.name:sub(20,20)][event.element.name] or 0) + 1
				end
			end
		elseif event.button == defines.mouse_button_type.right then
			if event.shift then
				global.talents[event.player_index][event.element.parent.name:sub(20,20)][event.element.name] = math.max(0,(global.talents[event.player_index][event.element.parent.name:sub(20,20)][event.element.name] or 0) - 5)
			else
				global.talents[event.player_index][event.element.parent.name:sub(20,20)][event.element.name] = math.max(0,(global.talents[event.player_index][event.element.parent.name:sub(20,20)][event.element.name] or 0) - 1)
			end
		end
		--verify_talents(game.players[event.player_index])
		talents_gui(game.players[event.player_index])
	elseif event.element.name == "dota_talents_close" then
		event.element.parent.parent.destroy()
		global.talents[event.player_index].ready = true
		apply_talents(game.players[event.player_index])
	--elseif event.element.name == "dota_talents_copypaste_button" then
	--	local player = game.players[event.player_index]
	--	local unbased,unbased_ret = pcall(base64.decode,event.element.parent.dota_talents_copypaste.text)
	--	--local unbased = base64.decode(event.element.parent.dota_talents_copypaste.text)
	--	--local unbased =event.element.parent.dota_talents_copypaste.text
	--	if unbased then
	--		local decompressed,decompressed_ret = pcall(LibDeflate_DecompressZlib,unbased_ret)
	--		--local decompressed = LibDeflate:DecompressZlib(unbased)
	--		if decompressed then
	--			local talents_status, talents = pcall(decode,decompressed_ret)
	--			--local talents =decode(decompressed)
	--			--local talents =decode(unbased)
	--			if talents_status then
	--				global.talents[player.index] = talents
	--				talents_gui(player)
	--			else
	--				player.print("JSON failed")
	--			end
	--		else
	--			player.print("decompress failed")
	--		end
	--	else
	--		player.print("base64 failed")
	--	end
	end
end
function verify_talents(player)
	for rgb, data in pairs(global.talents[player.index]) do
		for id, amount in pairs(data) do
			if amount == 0 then
				global.talents[player.index][rgb][id] = nil
			end
		end
	end
	local ret = {r={spent = 0, over_spent = 0, width = 8},g={spent = 0,over_spent = 0, width = 8},b={spent = 0,over_spent = 0, width = 8},a=0,total_spent = 0}
	local total_spent = 0
	local over_spent = 0
	for rgb, data in pairs(global.talents[player.index]) do
		for _, amount in pairs(data) do
			ret[rgb].spent = (ret[rgb].spent or 0) +amount
			--total_spent = total_spent + amount
		end
		--if ret[rgb].spent > 8 then
		--	local a= math.min(4-ret["a"],ret[rgb].spent-8)
		--	ret["a"] = ret["a"] +a
		--	ret[rgb].over_spent = ret[rgb].spent - a - 8
		--elseif ret[rgb].spent < 8 then
		--	spare = spare + (8-ret[rgb].spent)
		--end
		total_spent = total_spent + math.min(8, ret[rgb].spent)
		if ret[rgb].spent > 8 then
			local a= math.min(4-ret["a"],ret[rgb].spent-8)
			ret["a"] = ret["a"] +a
			total_spent = total_spent + a
			if ret[rgb].spent > 8+a then
				total_spent = total_spent + 2*(ret[rgb].spent - a - 8)
				ret[rgb].over_spent = ret[rgb].spent - a - 8
				over_spent = over_spent + ret[rgb].spent - a - 8
			end
			ret[rgb].width = ret[rgb].spent
		end
	end
	over_spent = over_spent * 2
	local remaining_points = 28-total_spent
	local temp_over_spent = over_spent
	local remaining_points_till_8 = 0
	for rgb, data in pairs(ret) do
		if rgb ~= "a" and rgb ~="total_spent" then
		if data.spent < 8 then
			remaining_points_till_8 = remaining_points_till_8 +8-data.spent
		end
		end
	end
	for rgb, data in pairs(ret) do
		if rgb ~= "a" and rgb ~="total_spent" then
		if data.spent < 8 then
			--local spare = math.min(math.max(0,8-data.spent), over_spent)
			--over_spent= over_spent-spare
			--data.width = data.width - spare
			data.width = data.width-(8-data.spent)/remaining_points_till_8*over_spent
		end
		end
	end
	ret.total_spent = total_spent
	return ret
end
function filter_clicks(button, input)
	--local filter = {
	--	["left-and-right"] = false,
	--	["left"] = false,
	--	["right"] = false,
	--	["middle"] = false,
	--	["button-4"] = false,
	--	["button-5"] = false,
	--	["button-6"] = false,
	--	["button-7"] = false,
	--	["button-8"] = false,
	--	["button-9"] = false,
	--}
	--filter[input] = true
	--for button_name, bool in pairs(filter) do
	--	--button.mouse_button_filter[button_name] = bool
	--end
	button.mouse_button_filter = {input}
end
function talents_gui(player)
	if not global.talents then global.talents = {} end
	if not global.talents[player.index] then global.talents[player.index] = {r={},g={},b={}} end
	local verified_talents = verify_talents(player)
	if player.gui.center.talents_gui then player.gui.center.talents_gui.destroy() end
	local gui = player.gui.center.add{type="frame",name = "talents_gui", direction="vertical"}
	gui.style.width = 668
	local header_flow = gui.add{type="flow", name = "header_flow", direction = "horizontal"}
	local copypaste = header_flow.add{type="textfield", name = "dota_talents_copypaste"}
	--local copypaste_button = header_flow.add{type="button", name = "dota_talents_copypaste_button", caption="load"}
	--copypaste_button.style.width = 50
	copypaste.style.font="default-tiny-bold"
	copypaste.style.width = 620
	local talents_string = encode(global.talents[player.index])
	local compressed =  LibDeflate_CompressZlib(talents_string)
	local b64 = base64.encode( compressed)
	copypaste.text = b64
	if verified_talents.total_spent >=28 then
		local temp = header_flow.add{type = "sprite-button", name= "dota_talents_close", sprite = "dotamarket_close"}
		temp.style.height = 29
		temp.style.width = 29
	end
	local flow = gui.add{type="flow", name = "flow", direction = "horizontal"}
	if verified_talents.total_spent <28 or verified_talents.r.width >0 then
		local r = flow.add{type="progressbar", name="pr", style = "dota_red_bar"}
		r.style.width = 190*verified_talents.r.width/8
		remove_margin_padding(r)
		r.style.right_margin = -5
		r.style.left_margin = -9
		r.style.color= {r=1,g=0,b=0}
		r.value = math.min(1,verified_talents.r.spent/verified_talents.r.width)
	end
	if verified_talents.total_spent <28 or verified_talents.g.width >0 then
		local g = flow.add{type="progressbar", name="pg", style = "dota_green_bar"}
		g.style.width = 190*verified_talents.g.width/8
		remove_margin_padding(g)
		g.style.right_margin = -5
		g.style.color = {r=0,g=1,b=0}
		g.value = math.min(1,verified_talents.g.spent/verified_talents.g.width)
	end
	if verified_talents.total_spent <28 or verified_talents.b.width >0 then
		local b = flow.add{type="progressbar", name="pb", style = "dota_blue_bar"}
		b.style.width = 190*verified_talents.b.width/8
		remove_margin_padding(b)
		b.style.right_margin = -5
		b.style.color = {r=0,g=0,b=1}
		b.value = math.min(1,verified_talents.b.spent/verified_talents.b.width)
	end
	if verified_talents.a <4 then
		local a = flow.add{type="progressbar", name="pa", style = "dota_white_bar"}
		a.style.width = 95*(4-verified_talents.a)/4
		remove_margin_padding(a)
		a.style.color = {r=1,g=1,b=1}
		a.value = 0
	end
	local tbl = gui.add{type="table",name="talent_list",column_count = 3}
	tbl.vertical_centering = false
	tbl.draw_vertical_lines = true
	tbl.style.right_cell_padding = 0
	tbl.style.left_cell_padding = 0
	tbl.style.width=652
	tbl.style.horizontal_spacing = 5
	
	local fr = tbl.add{type="flow", name = "r", direction = "vertical"}
	remove_margin_padding(fr)
	fr.style.height = 250
	fr.style.width = 175
	--fr.style.right_margin = -50
	local i=1
	for name in pairs(global.talents.r) do
		local temp_flow = fr.add{type="flow", name="dota_talent_choice_r_"..i, direction = "horizontal"}
		local label = temp_flow.add{type="label", name = "l"..i}
		remove_margin_padding(label)
		label.style.font = "default-bold"
		label.style.height = 20
		label.style.width = 20
		label.style.right_margin = -7
		label.style.left_margin = 3
		label.style.top_margin = -1
		label.caption=global.talents[player.index]["r"][name] or 0
		local button
		if verified_talents["r"].spent >= 8 then
			if verified_talents.total_spent >= 27 and verified_talents.a == 4  then
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_gray_button"}
				if not global.talents[player.index].r[name] or global.talents[player.index].r[name] == 0 then
					button.enabled = false
				else
					filter_clicks(button, "right")
				end
			elseif verified_talents["a"] < 4 then
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_yellow_button"}
			else
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_orange_button"}
			end
		elseif verified_talents.total_spent >= 28 then
			button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_gray_button"}
			if not global.talents[player.index].r[name] or global.talents[player.index].r[name] == 0 then
				button.enabled = false
			else
				filter_clicks(button, "right")
			end
		else
			button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_white_button"}
			if not global.talents[player.index].r[name] or global.talents[player.index].r[name] == 0 then
				filter_clicks(button, "left")
			end
		end
		remove_margin_padding(button)
		button.style.height = 20
		button.style.width = 185
		button.style.horizontal_align="left"
		button.style.horizontally_stretchable = true
		button.style.top_padding = -2

		i=i+1
	end
	
	local fg = tbl.add{type="flow", name = "g", direction = "vertical"}
	remove_margin_padding(fg)
	fg.style.height = 250
	fg.style.width = 175
	--fg.style.right_margin = -50
	local i=1
	for name in pairs(global.talents.g) do
		local temp_flow = fg.add{type="flow", name="dota_talent_choice_g_"..i, direction = "horizontal"}
		local label = temp_flow.add{type="label", name = "l"..i}
		remove_margin_padding(label)
		label.style.font = "default-bold"
		label.style.height = 20
		label.style.width = 20
		label.style.right_margin = -7
		label.style.left_margin = 3
		label.style.top_margin = -1
		label.caption=global.talents[player.index]["g"][name] or 0
		local button
		if verified_talents["g"].spent >= 8 then
			if verified_talents.total_spent >= 27 and verified_talents.a == 4 then
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_gray_button"}
				if not global.talents[player.index].g[name] or global.talents[player.index].g[name] == 0 then
					button.enabled = false
				else
					filter_clicks(button, "right")
				end
			elseif verified_talents["a"] < 4 then
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_yellow_button"}
			else
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_orange_button"}
			end
		elseif verified_talents.total_spent >= 28 then
			button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_gray_button"}
			if not global.talents[player.index].g[name] or global.talents[player.index].g[name] == 0 then
				button.enabled = false
			else
				filter_clicks(button, "right")
			end
		else
			button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_white_button"}
			if not global.talents[player.index].g[name] or global.talents[player.index].g[name] == 0 then
				filter_clicks(button, "left")
			end
		end
		remove_margin_padding(button)
		button.style.height = 20
		button.style.width = 185
		button.style.horizontal_align="left"
		button.style.horizontally_stretchable = true
		button.style.top_padding = -2
		i=i+1
	end
	
	local fb = tbl.add{type="flow", name = "b", direction = "vertical"}
	remove_margin_padding(fb)
	fb.style.height = 250
	fb.style.width = 175
	--fb.style.right_margin = -50
	local i=1
	for name in pairs(global.talents.b) do
		local temp_flow = fb.add{type="flow", name="dota_talent_choice_b_"..i, direction = "horizontal"}
		local label = temp_flow.add{type="label", name = "l"..i}
		remove_margin_padding(label)
		label.style.font = "default-bold"
		label.style.height = 20
		label.style.width = 20
		label.style.right_margin = -7
		label.style.left_margin = 3
		label.style.top_margin = -1
		label.caption=global.talents[player.index]["b"][name] or 0
		local button
		if verified_talents["b"].spent >= 8 then
			if verified_talents.total_spent >= 27 and verified_talents.a == 4 then
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_gray_button"}
				if not global.talents[player.index].b[name] or global.talents[player.index].b[name] == 0 then
					button.enabled = false
				else
					filter_clicks(button, "right")
				end
			elseif verified_talents["a"] < 4 then
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_yellow_button"}
			else
				button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_orange_button"}
			end
		elseif verified_talents.total_spent >= 28 then
			button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_gray_button"}
			if not global.talents[player.index].b[name] or global.talents[player.index].b[name] == 0 then
				button.enabled = false
			else
				filter_clicks(button, "right")
			end
		else
			button = temp_flow.add{type="button", name = name, caption = global.talent_localizations[name], style="dota_white_button"}
			if not global.talents[player.index].b[name] or global.talents[player.index].b[name] == 0 then
				filter_clicks(button, "left")
			end
		end
		
		remove_margin_padding(button)
		button.style.height = 20
		button.style.width = 185
		button.style.horizontal_align="left"
		button.style.horizontally_stretchable = true
		button.style.top_padding = -2
		i=i+1
	end
	
end


function sort_items(array)
	local temp = {}
	local i = 1
	local itemcounts = {}
	for _, e in pairs(array) do
		itemcounts[e.item] = (itemcounts[e.item] or 0)+e.count
	end
	for name, count in pairs(itemcounts) do
		while count > 0 do
			local tempcount = math.min((global.items[name].stack_size or 1), count)
			count = count - tempcount
			table.insert(temp, {item = name, count = tempcount})
		end
	end
	return temp
end
function insert_item (player, item)
	if not global.items[item].stack_size then
		table.insert(global.players[player.index].items, {item = item, count = 1})
	else
		local once = false
		for _, data in pairs(global.players[player.index].items) do
			if not once then
				if data.item == item and data.count < global.items[item].stack_size then
					data.count = data.count + 1
					once= true
				end
			end
		end
		if not once then
			table.insert(global.players[player.index].items, {item = item, count = 1})
		end
	end
end
script.on_nth_tick(3603,function(event)
	if not global.players then return end
	for index, data in pairs(global.players) do
		player=game.players[index]
		for _, modifier in pairs(data.modifiers) do
			if modifier.periodical then
				modifier.periodical = modifier.periodical +1
				local mult = 1
				add_modifier(player,modifier,mult)
			end
		end
		for _, modifier in pairs(data.talent_modifiers) do
			if modifier.periodical then
				modifier.periodical = modifier.periodical +1
				local mult = 1
				add_modifier(player,modifier,mult)
			end
		end
	end
end)
function remove_modifier(player, modifier, mult)
	if not mult then mult = 1 end
	if modifier.type == "force" then
		if modifier.modifier == "gun_speed_modifier" then
			if not modifier.ammo then
				for a in pairs(game.ammo_category_prototypes) do 
					local new_mod = math.max(0,player.force.get_gun_speed_modifier(a) - modifier.value*mult)
					if new_mod < 0.00000001 then
						new_mod = 0
					end
					player.force.set_gun_speed_modifier(a, new_mod )
				end
			else
				local new_mod = math.max(0,player.force.get_gun_speed_modifier(modifier.ammo) - modifier.value*mult)
				if new_mod < 0.00000001 then
					new_mod = 0
				end
				player.force.set_gun_speed_modifier(modifier.ammo, new_mod)
			end
		elseif modifier.modifier =="ammo_damage_modifier" then
			if not modifier.ammo then
				for a in pairs(game.ammo_category_prototypes) do
					local new_mod = math.max(0,player.force.get_ammo_damage_modifier(a) - modifier.value*mult)
					if new_mod < 0.00000001 then
						new_mod = 0
					end
					player.force.set_ammo_damage_modifier(a, new_mod)
				end
				local new_mod = math.max(0,global.players[player.index].bonuses.chardamage_mult -modifier.value*mult)
				if new_mod < 0.00000001 then
					new_mod = 0
				end
				global.players[player.index].bonuses.chardamage_mult = new_mod
			else
				local new_mod = math.max(0,player.force.get_ammo_damage_modifier(modifier.ammo) - modifier.value*mult)
				if new_mod < 0.00000001 then
					new_mod = 0
				end
				player.force.set_ammo_damage_modifier(modifier.ammo, new_mod)
			end
		elseif modifier.modifier =="turret_attack_modifier" then
			if not modifier.turret then
				for t, data in pairs(game.entity_prototypes) do
					if data.type == "fluid-turret" or data.type == "ammo-turret" or data.type == "electric-turret" then
						local new_mod = math.max(0,player.force.get_turret_attack_modifier(t) - modifier.value*mult)
						if new_mod < 0.00000001 then
							new_mod = 0
						end
						player.force.set_turret_attack_modifier(t, new_mod)
					end
				end
			else
				local new_mod = math.max(0,player.force.get_turret_attack_modifier(modifier.turret) - modifier.value*mult)
				if new_mod < 0.00000001 then
					new_mod = 0
				end
				player.force.set_turret_attack_modifier(modifier.turret, new_mod)
			end
		else
			local new_mod = math.max(0,player.force[modifier.modifier] - modifier.value*mult)
			if new_mod < 0.00000001 then
				new_mod = 0
			end
			player.force[modifier.modifier] = new_mod
		end
	elseif modifier.type == "other" then
		--if modifier.modifier == "income" then
			local new_mod = global.players[player.index].bonuses[modifier.modifier] - modifier.value*mult
			if new_mod < 0.00000001 then
				new_mod = 0
			end
			global.players[player.index].bonuses[modifier.modifier] = new_mod
		--end
	elseif modifier.type == "giveitem" then
		local new_mod = math.max(0,global.players[player.index].giveitem[modifier.item] - modifier.per_second*mult)
		if new_mod < 0.00000001 then
			new_mod = 0
		end
		global.players[player.index].giveitem[modifier.item] = new_mod
	elseif modifier.type == "spellpack" then
		if remote.interfaces["spell-pack"] then
			local players =remote.call("spell-pack","get","players")
			local new_mod = players[player.index][modifier.modifier]- modifier.value*mult
			players[player.index][modifier.modifier] = new_mod
			remote.call("spell-pack","set","players",players)
		end
	end
end

function add_modifier(player, modifier, mult)
	if not mult then mult = 1 end
	if modifier.type == "force" then
		if modifier.modifier == "gun_speed_modifier" then
			if not modifier.ammo then
				for a in pairs(game.ammo_category_prototypes) do 
					player.force.set_gun_speed_modifier(a, math.max(0,player.force.get_gun_speed_modifier(a) + modifier.value*mult))
				end
			else
				player.force.set_gun_speed_modifier(modifier.ammo, math.max(0,player.force.get_gun_speed_modifier(modifier.ammo) + modifier.value*mult))
			end
		elseif modifier.modifier =="ammo_damage_modifier" then
			if not modifier.ammo then
				for a in pairs(game.ammo_category_prototypes) do 
					player.force.set_ammo_damage_modifier(a, math.max(0,player.force.get_ammo_damage_modifier(a) + modifier.value*mult))
				end
				global.players[player.index].bonuses.chardamage_mult = global.players[player.index].bonuses.chardamage_mult +modifier.value*mult
			else
				player.force.set_ammo_damage_modifier(modifier.ammo, math.max(0,player.force.get_ammo_damage_modifier(modifier.ammo) + modifier.value*mult))
			end
		elseif modifier.modifier =="turret_attack_modifier" then
			if not modifier.turret then
				for t, data in pairs(game.entity_prototypes) do
					if data.type == "fluid-turret" or data.type == "ammo-turret" or data.type == "electric-turret" then
						player.force.set_turret_attack_modifier(t, math.max(0,player.force.get_turret_attack_modifier(t) + modifier.value*mult))
					end
				end
			else
				player.force.set_turret_attack_modifier(modifier.turret, math.max(0,player.force.get_turret_attack_modifier(modifier.turret) + modifier.value*mult))
			end
		else
			player.force[modifier.modifier] = player.force[modifier.modifier] + modifier.value*mult
		end
	elseif modifier.type == "other" then
		--if modifier.modifier == "income" then
			global.players[player.index].bonuses[modifier.modifier] = global.players[player.index].bonuses[modifier.modifier] + modifier.value*mult
		--end
	elseif modifier.type == "giveitem" then
		global.players[player.index].giveitem[modifier.item] = (global.players[player.index].giveitem[modifier.item] or 0) + modifier.per_second*mult
	elseif modifier.type == "spellpack" then
		if remote.interfaces["spell-pack"] then
			local players =remote.call("spell-pack","get","players")
			local new_mod = players[player.index][modifier.modifier]+ modifier.value*mult
			players[player.index][modifier.modifier] = new_mod
			remote.call("spell-pack","set","players",players)
		end
	end
end

function remove_modifiers(player, tbl)
	local stack_cache = {}
	for _, modifier in pairs(tbl) do
		--if modifier.type == "player" then
		--	player[modifier.modifier] = math.max(0,player[modifier.modifier] - modifier.value)
		--else
		local mult = 1
		if modifier.periodical then
			mult = modifier.periodical
			table.insert(stack_cache, {type = modifier.type, modifier = modifier.modifier, ammo= modifier.ammo, value = modifier.value, turret = modifier.turret, periodical = mult})
		end
		remove_modifier(player, modifier, mult)
	end
	return stack_cache
end

function add_modifiers(player, tbl, stack_cache)
	for _, mod in pairs(tbl) do
		local modifier = deepcopy(mod)
		local mult = 1
		if modifier.periodical then
			mult, stack_cache = get_stack(modifier, stack_cache)
			--if mult > 0 then
				modifier.periodical = mult
			--else
			--	mult = 1
			--end
		end
		--if modifier.type == "player" then
		--	player[modifier.modifier] = player[modifier.modifier] + modifier.value
		--else
		add_modifier(player, modifier, mult)
		table.insert(global.players[player.index].modifiers, modifier)
	end
	return stack_cache
end

function get_stack(modifier, stack_cache)
	local type = modifier.type
	local mod = modifier.modifier
	local ammo = modifier.ammo
	local value = modifier.value
	local turret = modifier.turret
	local biggest_mult = 0
	for i, mod2 in pairs(stack_cache) do
		if type == mod2.type and mod == mod2.modifier and ammo== mod2.ammo and value == mod2.value and turret == mod2.turret then		--, periodical = mult}
			biggest_mult = mod2.periodical
		end
	end
	for i, mod2 in pairs(stack_cache) do
		if type == mod2.type and mod == mod2.modifier and ammo== mod2.ammo and value == mod2.value and turret == mod2.turret and mod2.periodical == biggest_mult then		--, periodical = mult}
			stack_cache[i] = nil
		end
	end
	return biggest_mult, stack_cache
end

function update_items(player)
	local i = 1
	local stacks = remove_modifiers(player,global.players[player.index].modifiers)
	global.players[player.index].modifiers = {}
	for _, data in pairs(global.players[player.index].items) do
		player.gui.left.dota_item_gui.equipment_table["item_"..i].sprite = data.item
		player.gui.left.dota_item_gui.equipment_table["item_"..i].tooltip = global.items[data.item].name.."\n\n"..global.items[data.item].description
		if global.items[data.item].stack_size then
			player.gui.left.dota_item_gui.equipment_table["item_"..i].number = data.count
		else
			player.gui.left.dota_item_gui.equipment_table["item_"..i].number = nil
		end
		player.gui.left.dota_item_gui.equipment_table["item_"..i].clear()
		if global.players[player.index].item_cooldowns[data.item] then
			local bar = player.gui.left.dota_item_gui.equipment_table["item_"..i].add{type = "progressbar", name = "cd", value = (global.players[player.index].item_cooldowns[data.item]/global.items[data.item].cooldown)}
			bar.style.color = {r=1,g=1,b=0}
			bar.style.width = 24
			bar.style.top_padding = 0
			bar.style.bottom_padding = 0
			bar.style.left_padding = 0
			bar.style.right_padding = 0
			bar.style.top_margin = 0
			bar.style.bottom_margin = 0
			bar.style.left_margin = -1
			bar.style.right_margin = 0
		end
		stacks = add_modifiers(player,global.items[data.item].effects, stacks)
		i=i+1
	end
	for j=i, 6 do
		player.gui.left.dota_item_gui.equipment_table["item_"..j].sprite = "transparent32"
		player.gui.left.dota_item_gui.equipment_table["item_"..i].tooltip = ""
		player.gui.left.dota_item_gui.equipment_table["item_"..i].number = nil
		player.gui.left.dota_item_gui.equipment_table["item_"..i].clear()
	end
end

function lock_items(player)
	for _, elem in pairs(player.gui.left.dota_item_gui.equipment_table.children) do
		--print("'"..elem.sprite.."'")
		if elem.sprite ~="" and elem.sprite ~="transparent32" and global.items[elem.sprite].func then
			elem.ignored_by_interaction = false
		else
			elem.ignored_by_interaction = true
		end
	end
end
function unlock_items(player)
	for _, elem in pairs(player.gui.left.dota_item_gui.equipment_table.children) do
		elem.ignored_by_interaction = false
	end
end



function style_item_button(elem)
		elem.style.width = 30
		elem.style.height = 30
		elem.style.top_padding = 0
		elem.style.right_padding = 0
		elem.style.left_padding = 0
		elem.style.bottom_padding = 0
end

function remove_parts(player,itemname, only_calculate_price)
	local price = global.items[itemname].price
	local tableremove = {}
	if global.items[itemname].parts then
		for _, part in pairs(global.items[itemname].parts) do
			local removed_amount = 0
			for i, data in pairs( global.players[player.index].items ) do
				if removed_amount < part.count then
					if data.item == part.name then
						if data.count == 1 then
							if not only_calculate_price then
								--table.remove(global.players[player.index].items,i)
								global.players[player.index].items[i] = nil
							end
							removed_amount = removed_amount +1
						else
							local temp = math.min(data.count, part.count-removed_amount)
							if not only_calculate_price then
								data.count = data.count - temp
								if data.count == 0 then
									--table.remove(global.players[player.index].items,i)
									global.players[player.index].items[i] = nil
								end
							end
							removed_amount = removed_amount + temp
						end
					end
				end
			end
			for i=1, (part.count - removed_amount) do
				price = price + remove_parts(player,part.name, only_calculate_price)
			end
		end
	end
	return price
end
function recursive_can_insert (player,itemname)
	local cleared_slots = 0
	local price = global.items[itemname].price
	if global.items[itemname].parts then
		for _, part in pairs(global.items[itemname].parts) do
			local removed_amount = 0
			for i, data in pairs( global.players[player.index].items ) do
				if removed_amount < part.count then
					if data.item == part.name then
						if data.count == 1 then
							cleared_slots = cleared_slots + 1
							removed_amount = removed_amount +1
						else
							local temp = math.min(data.count, part.count-removed_amount)
							
							--data.count = data.count - temp
							if data.count == temp then
								cleared_slots = cleared_slots + 1
							end
							
							removed_amount = removed_amount + temp
						end
					end
				end
			end
			for i=1, (part.count - removed_amount) do
				cleared_slots = cleared_slots + recursive_can_insert(player,part.name)
			end
		end
	end
	return cleared_slots
end

function can_insert_item(player, item)
	if table_length(global.players[player.index].items) < 6 then
		return true
	elseif global.items[item].stack_size then
		for _, data in pairs(global.players[player.index].items) do
			if data.item == item and item.count < global.items[item].stack_size then
				return true
			end
		end
	else
		if recursive_can_insert(player,item)>0 then
			return true
		end
	end
	return false
end

function get_sell_price(itemname)
	local price = global.items[itemname].price
	if global.items[itemname].parts then
		for _, part in pairs(global.items[itemname].parts) do
			price = price + get_sell_price(part.name) * part.count
		end
	end
	return price
end

function buy_item(player, itemname, only_calculate_price)
	local price = remove_parts(player,itemname,only_calculate_price)
	if only_calculate_price then 
		return price
	elseif global.players[player.index].money >= price and can_insert_item(player, itemname) then
		global.players[player.index].items = sort_items(global.players[player.index].items)
		global.players[player.index].money = global.players[player.index].money - price
		insert_item(player,itemname)
		update_items(player)
		player.gui.left.dota_item_gui.money.caption = math.floor(global.players[player.index].money).."[img=dota-coin]"
		open_market(player)
	end
end

function open_market(player, selected_item)
	if not selected_item then
		if player.gui.center.dota_market and player.gui.center.dota_market.children[2] then
			selected_item = player.gui.center.dota_market.children[2].name
		end
	end
	if player.gui.center.dota_market then player.gui.center.dota_market.destroy() end
	local gui = player.gui.center.add{type="frame", name="dota_market", direction = "vertical"}
	gui.style.horizontal_align = "center"
	--gui.style.width = 600
	local table = gui.add{type="table", name = "market_table", column_count = 8}
	--table.style.minimal_height = 300
	local excluded_items = {}
	for name, data in pairs(global.items) do
		if data.parts then
			for _, data2 in pairs(data.parts) do
				excluded_items[data2.name] = true
			end
		end
	end
	for name, data in pairs(global.items) do
		if not excluded_items[name] or global.items[name].always_show_in_main_list then
			local button = table.add{type="sprite-button", name = name, number=buy_item(player,name,true), sprite = name}
			button.tooltip = data.name.."\n\n"..data.description
			style_item_button(button)
			button.style.width = 50
			button.style.height = 50
		end
	end
	if selected_item then
		local parts_table = gui.add{type="flow", name = selected_item}
		parts_table.style.top_margin = 30
		--parts_table.style.width = 600
		parts_table.style.horizontally_stretchable = true
		parts_table.style.horizontal_align = "center"
		--local test = parts_table.add{type="label", name="asd", caption="ASD"}
		--test.style.horizontal_align = "center"
		add_parts_to_gui(player,selected_item, parts_table,1)
	end
	player.opened = gui
end
function get_amount_in_inventory(player,item)
	local count = 0
	for i, data in pairs( global.players[player.index].items ) do
		if data.item == item then
			count = count + data.count
		end
	end
	return count
end
function add_parts_to_gui(player,item, gui, amount)
	local main_flow = gui.add{type="flow", name=item, direction = "vertical"}
	main_flow.style.horizontal_align = "center"
	local flow = main_flow.add{type="flow", name="market_buy_item", direction = "vertical"}
	flow.style.horizontal_align = "center"
	local button = flow.add{type="sprite-button", name=item, sprite = item, number = buy_item(player,item,true)}
	button.tooltip = global.items[item].name.."\n\n"..global.items[item].description
	style_item_button(button)
	button.style.width = 50
	button.style.height = 50
	local inventory_amount = get_amount_in_inventory(player,item)
	local label = flow.add{type="label", name = "cap", caption = inventory_amount.."/"..amount}
	label.style.font = "default-bold"
	if inventory_amount < amount then
		label.style.font_color = {r=0.7,g=0.7,b=0.7}
	end
	if global.items[item].parts then
		local partstable = main_flow.add{type="table", name = "parts", column_count = #global.items[item].parts}
		partstable.style.cell_padding =7
		partstable.vertical_centering =false
		partstable.draw_vertical_lines=true
		partstable.style.horizontal_align = "center"
		for _, part in pairs(global.items[item].parts) do
			add_parts_to_gui(player,part.name, partstable, part.count)
		end
	end
			

end
function create_equipment_gui(player)
	local gui = player.gui.left.add{type = "frame", name= "dota_item_gui", direction= "vertical"}
	local table = gui.add{type = "table", name = "equipment_table", column_count = 2}
	for i=1,6 do
		local button = table.add{type = "sprite-button", name = "item_"..i}
		button.ignored_by_interaction = true
		style_item_button(button)

	end
	gui.add{type = "label", name ="money", caption = math.floor(global.players[player.index].money).."[img=dota-coin]"}
end

function deepcopy(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[deepcopy(orig_key)] = deepcopy(orig_value)
        end
        setmetatable(copy, deepcopy(getmetatable(orig)))
    else -- number, string, boolean, etc
        copy = orig
    end
    return copy
end